VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{B92DC4FA-1274-439E-844A-AD77E176C306}#1.0#0"; "roc8.ocx"
Begin VB.Form FrmReportPreview 
   BackColor       =   &H80000005&
   Caption         =   "Report Preview"
   ClientHeight    =   10155
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   14955
   LinkTopic       =   "Form1"
   ScaleHeight     =   10155
   ScaleWidth      =   14955
   StartUpPosition =   3  'Windows Default
   Begin ROCLib.Roc Rep1 
      Height          =   9975
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   14535
      _Version        =   65536
      _ExtentX        =   25638
      _ExtentY        =   17595
      _StockProps     =   160
      DesignMode      =   0   'False
      BackColor       =   8388736
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1080
      Top             =   2160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuSave 
         Caption         =   "Save As..."
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPrint 
         Caption         =   "&Print"
      End
      Begin VB.Menu mnuPrintPreview 
         Caption         =   "Print Pre&view"
      End
      Begin VB.Menu mnuSep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuJump 
         Caption         =   "&Goto Page"
      End
      Begin VB.Menu mnuSep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy to Clipboard"
      End
   End
End
Attribute VB_Name = "FrmReportPreview"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' This routine sorts the CUSTOMER file.  It also creates
' a combined by joining the sorted CUSTOMER file and the
' SALES file
'
Private Sub PrepareFile(RepParm As TypeRep)
   Dim i As Integer
   Static KeyFieldNo(10)  As Long
   Dim temp As Integer
   Dim field As TypeField
   Dim OutName As String

   ' prepare the sorted file name
   OutName = "temp" + Str(RepParm.ReportId) + ".srt"

   ' sort the customer file
   For i = 0 To RepParm.TotalSortFields - 1   ' Get the sort fields
      temp = RvbGetSortField(Rep1.pCtl, i, field) 'get the sort field name
      KeyFieldNo(i) = field.FieldId + 1
   Next i
   temp = FileSort(App.Path & "\" & DataFile(0).name + ".DB", App.Path & "\" & OutName, RepParm.TotalSortFields, KeyFieldNo(0))

   ' The sorted records are stored in the TEMPnnn.SRT file
   '    Where nnn is the report id

   ' Check if the SALES file is used for this report
   SalesFileUsed = False
   For i = 0 To RepParm.TotalFields
      temp = RvbGetDataField(Rep1.pCtl, i, field) ' get the field information
      If field.FileId = 1 Then
         SalesFileUsed = True
         Exit For
      End If
   Next i

   If Not SalesFileUsed Then Exit Sub  ' do not need to join the sales file

   ' Join the SALES.DB file to the CUSTOMER.SRT file
   ' These two files have the first common field (customer id)
   temp = FileJoin(App.Path & "\" & OutName, 1, App.Path & "\" & DataFile(1).name + ".DB", 1, App.Path & "\" & OutName)

   ' The output records are stored in the CUSTOMER.SRT file

End Sub

'  This routine reads each record from the sorted data file
'  (CUSTOMER.SRT) and fills the values for the report fields
'  and calls the RvbRec function pass the data to the
'  report executor.
'
Private Sub PrintRecords(RepParm As TypeRep)
   Dim i As Integer
   Dim CurLen As Integer
   Dim iFile As Integer
   Dim FileNo As Integer
   Dim FieldNo As Integer
   Dim RecoNo  As Integer
   Dim DataSetName As String
   Dim DataValue As Variant
   Dim FileName As String
   Dim temp As Integer
   Dim field As TypeField
   Dim MaxFiles As Integer
   Dim FieldSource As Long
   Dim FieldType As Long
   Dim FileId As Long
   Dim FieldId As Long

   ' open the sorted data file
   FileName = "temp" + Str(RepParm.ReportId) + ".SRT"

   iFile = 1
   Open App.Path & "\" & FileName For Input Access Read As #iFile

   ' Check if SALES data file is used
   If SalesFileUsed Then MaxFiles = MAX_FILES Else MaxFiles = 1

   ' Retrieve the information about the fields used in this report
   For i = 0 To RepParm.TotalFields - 1
      temp = RvbGetDataField(Rep1.pCtl, i, field)
      RepFieldSource(i) = field.source
      RepFieldType(i) = field.type
      RepFieldId(i) = field.FieldId
      RepFileId(i) = field.FileId
   Next i


READ_RECORD:
   ' Initialize the field structure
   For i = 0 To RepParm.TotalFields - 1
      If RepFieldSource(i) = SRC_APPL Then
        If RepFieldType(i) = TYPE_TEXT Then temp = RvbSetTextField(Rep1.pCtl, i, "", 0)
        If RepFieldType(i) = TYPE_NUM Then temp = RvbSetNumField(Rep1.pCtl, i, (0))
        If RepFieldType(i) = TYPE_DBL Then temp = RvbSetNumField(Rep1.pCtl, i, (0))
      End If
   Next i

   ' read fields values for the next record
   For FileNo = 0 To MaxFiles - 1
     For FieldNo = 0 To DataFile(FileNo).TotalFields - 1
       ErrorCode = 0
       On Error GoTo PrintRecordsHandler
       Input #iFile, DataValue
       On Error GoTo 0
       If ErrorCode Then
          Close iFile
          Exit Sub
       End If

       ' Pass this data field to the VBX
       For i = 0 To RepParm.TotalFields - 1
          If RepFieldSource(i) = SRC_APPL And RepFileId(i) = FileNo And RepFieldId(i) = FieldNo Then
             If RepFieldType(i) = TYPE_TEXT Then temp = RvbSetTextField(Rep1.pCtl, i, DataValue, Len(DataValue))
             If RepFieldType(i) = TYPE_NUM Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_DBL Then temp = RvbSetDoubleField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_DATE Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             If RepFieldType(i) = TYPE_PICT Then temp = RvbSetNumField(Rep1.pCtl, i, DataValue)  ' pass picture id
             If RepFieldType(i) = TYPE_LOGICAL Then
                If DataValue = "Y" Or DataValue = "y" Then DataValue = 1 Else DataValue = 0
                temp = RvbSetNumField(Rep1.pCtl, i, DataValue)
             End If
          End If
       Next i
     Next FieldNo
   Next FileNo

   ' Print the record
   temp = RvbRec(Rep1.pCtl)
   If temp <> 0 Then     ' user aborted the report
     Close iFile
     Exit Sub
   End If

   GoTo READ_RECORD

PrintRecordsHandler:
   ErrorCode = Err
   Resume Next

End Sub

Sub RunReport(ByVal sFileName As String, ByVal sOutPutDevice As String, ByVal sOutputFile As String)

Dim lTemp As Long
Dim FileName As String
Dim EditingForm As Integer
Dim MergeFieldNames$
Dim MergeFieldData$

' fill the report parameter structure
RepParm.file = sFileName & Chr(0)  ' specify the file name
RepParm.device = sOutPutDevice

If RepParm.device = "R" Then
  RepParm.OutFile = sOutputFile & Chr(0)
End If

RepParm.x = FormParm.x            ' output window location
RepParm.y = FormParm.y
RepParm.width = FormParm.width    ' output window width
RepParm.height = FormParm.height  ' output window height

' Initialize the report executor
lTemp = RvbInit(Rep1.pCtl, RepParm)          ' initialize the report
If lTemp <> 0 Then Exit Sub

'SubSystems ReportEase can "import" or "attach" rtf formatted documents into the report.
'The SubSystems TE developer's kit is required for this feature.
'If you have purchased and installed the TE developer's kit or the demo, you can uncomment the line
'below to see the feature in action.
lTemp = RepSetRtfAttach(RepParm.ReportId, App.Path & "\letter1.rtf", True, MergeFieldNames$, MergeFieldData$)

' prepare the datafile for output
Call PrepareFile(RepParm)

' Do a preprocess pass if requested by the report executor
If (RepParm.DoPreprocessPass) Then
   lTemp = RepBeginPreprocessPass(RepParm.ReportId)
   Call PrintRecords(RepParm)
   lTemp = RepEndPreprocessPass(RepParm.ReportId)
End If

' Feed the records to the report executor
Call PrintRecords(RepParm)

' Close the report executor
lTemp = RvbExit(Rep1.pCtl)


End Sub

Private Sub Form_Load()
  'Dim BackColor
  'Dim BackColor2
  'Rep1.BackColor = &H80000010
  
  'BackColor = Rep1.BackColor
   
  
  'Rep1.BackColor = BackColor
  'BackColor2 = Rep1.BackColor
  
  'Debug.Print "bc: "; BackColor; "bc2: "; BackColor2; "init"; &H80000010
  
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Dim CloseWin As Long
  CloseWin = RepQueryExit(Rep1.hFrWnd)
  If CloseWin Then Cancel = 0 Else Cancel = 1
End Sub

Private Sub mnuCopy_Click()
  Rep1.Command = ID_COPY
End Sub

Private Sub mnuEdit_Click()
   mnuJump.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_JUMP)
   mnuJump.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_JUMP)
   mnuCopy.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_COPY)
   mnuCopy.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_COPY)
End Sub

Private Sub mnuExit_Click()
  Unload FrmReportPreview
End Sub

Private Sub mnuFile_Click()
   mnuSave.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_SAVE)
   mnuSave.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_SAVE)
   mnuJump.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_JUMP)
   mnuJump.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_JUMP)
   mnuPrint.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_PRINT)
   mnuPrint.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_PRINT)
   mnuPrintPreview.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_PREVIEW)
   mnuPrintPreview.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_PREVIEW)
   mnuExit.Enabled = RepMenuEnable(Rep1.hFrWnd, ID_EXIT)
   mnuExit.CHECKED = RepMenuSelect(Rep1.hFrWnd, ID_EXIT)

End Sub

Private Sub mnuJump_Click()
  Rep1.Command = ID_JUMP
End Sub


Private Sub mnuPrint_Click()
  Rep1.Command = ID_PRINT
End Sub

Private Sub mnuPrintPreview_Click()
  Rep1.Command = ID_PREVIEW
End Sub

Private Sub mnuSave_Click()
  Rep1.Command = ID_SAVE
End Sub

' This event is fired by the ReportExecutor when it needs
' your application to draw a picture.  This routine calls
' the RvbGetPictureInfo function to get the report device
' context, picture id, and rectangle locaton and size where
' the picture is to be drawn. This function also returns
' the file and field id for the picture field (this demo
' program does not use these two fields).
'
' This demo program draw different part of the same bitmap
' for different picture id.
'
Private Sub Rep1_DrawPicture(ByVal ReportId As Long)
   Dim PictInfo As TypePict
   Dim temp As Integer
   Dim PictWidth As Integer
   Dim PictX As Integer
   Dim PictY As Integer
   Dim PictHeight As Integer
   Dim PictFile As String

   ' get the report device context and picture rectangle
   temp = RvbGetPictureInfo(Rep1.pCtl, PictInfo)

   If PictInfo.FieldId = 11 Then ' draw a bitmap
     ' specify part of the bitmap to print as a percentage of the width and height
     If PictInfo.PictId < 1 Then PictInfo.PictId = 1
     If PictInfo.PictId > 10 Then PictInfo.PictId = 10

     PictX = (PictInfo.PictId - 1) * 10  'starting X location
     PictWidth = 10               'always print only 10 percent of the bitmap
     PictY = 0
     PictHeight = 100             ' print the entire height

     PictX = 0    ' test code
     PictWidth = 100
     
     ' The following statment uses the RvbDrawBitmap function
     ' to draw a part of the logo.bmp file.  The logo.bmp
     ' bitmap file is loaded into the 'Picture1' control.
     ' The 'AutoSize' property of the picture control MUST
     ' be TRUE so that the control does not clip the
     ' bitmap.

     temp = RvbDrawBitmap(Rep1.pCtl, frmMain.Picture1.hWnd, frmMain.Picture1.Image, PictX, PictY, PictWidth, PictHeight)

   ElseIf PictInfo.FieldId = 12 Then ' Draw an RTF memo field

     If PictInfo.PictId = 1 Then PictFile = "letter1.rtf" Else PictFile = "letter2.rtf"
     temp = RepDrawTerText(ReportId, PictFile + Chr(0), 0, 0, ByVal 0&, ByVal 0&)
   End If

End Sub

Private Sub Rep1_Progress(ByVal PagesPrinted As Long, Cancel As Long)
  'Debug.Print PagesPrinted, Cancel
  'If PagesPrinted = 1 Then Cancel = 1
End Sub
